---
policy: /ce/ca/aws/ec2/ebs-snapshot-old
logic: /ce/ca/aws/ec2/ebs-snapshot-old/prod.logic.yaml
executionTime: 2025-10-01T12:44:52.001457468Z
generationMs: 64
executionMs: 1038
rows:
  - id: '001'
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10__disappearanceTime__c)
      actual: isDisappeared(CA10__disappearanceTime__c)
    runtimeError: {}
  - id: '002'
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 299
      actual: 299
    conditionText:
      expected: extract('CA10__startTime__c').beyondLastDays(90)
      actual: extract('CA10__startTime__c').beyondLastDays(90)
    runtimeError: {}
  - id: '003'
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 300
      actual: 300
    conditionText:
      expected: otherwise
      actual: otherwise
    runtimeError: {}
  - id: '004'
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 300
      actual: 300
    conditionText:
      expected: otherwise
      actual: otherwise
    runtimeError: {}
  - id: '005'
    match: true
    status:
      expected: INAPPLICABLE
      actual: INAPPLICABLE
    conditionIndex:
      expected: 199
      actual: 199
    conditionText:
      expected: extract('CA10__state__c') != 'completed'
      actual: extract('CA10__state__c') != 'completed'
    runtimeError: {}
usedFiles:
  - path: /ce/ca/aws/ec2/ebs-snapshot-old/policy.yaml
    md5Hash: E255E0FDA3D7587872BB9E8C260E9567
    content: "---\nnames:\n  full: \"AWS EBS Snapshot is 90 days old or more\"\n \
      \ contextual: \"EBS Snapshot is 90 days old or more\"\ndescription: \"Consider\
      \ deleting or archiving AWS EBS Snapshots that \n  are 90 days old or more to\
      \ reduce storage costs and manage data lifecycle.\"\ntype: \"COMPLIANCE_POLICY\"\
      \ncategories:\n  - \"COST\"\nframeworkMappings:\n  - \"/frameworks/cloudaware/cost-efficiency-and-optimization/waste-reduction\""
  - path: /ce/ca/aws/ec2/ebs-snapshot-old/prod.logic.yaml
    md5Hash: CDC55CDE688BDD560C32D8764124AAC2
    content: |
      ---
      inputType: CA10__CaAwsSnapshot__c
      importExtracts:
        - file: "/types/CA10__CaAwsSnapshot__c/object.extracts.yaml"
      testData:
        - file: "test-data.json"
      conditions:
        - status: "INAPPLICABLE"
          currentStateMessage: "The snapshot is not completed."
          check:
            NOT_EQUAL:
              left:
                EXTRACT: "CA10__state__c"
              right:
                TEXT: "completed"
        - status: "INCOMPLIANT"
          currentStateMessage: "EBS Snapshot is 90 days old or more."
          remediationMessage: "Consider deleting or archiving the old snapshot."
          check:
            IS_BEYOND_LAST_DAYS:
              offsetDays: 90
              arg:
                EXTRACT: "CA10__startTime__c"
      otherwise:
        status: "COMPLIANT"
        currentStateMessage: "EBS snapshot is less than 90 days old."
  - path: /ce/ca/aws/ec2/ebs-snapshot-old/test-data.json
    md5Hash: 974FDBB190B6256D3C185D3B14E63232
    content: |-
      [
        {
          "expectedResult": {
            "status": "DISAPPEARED",
            "conditionIndex": "99",
            "conditionText": "isDisappeared(CA10__disappearanceTime__c)",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2025-07-28T16:54:52Z"
          },
          "Id": "001",
          "CA10__disappearanceTime__c": "2025-07-20T04:52:20Z",
          "CA10__state__c": "error",
          "CA10__startTime__c": "2025-07-06T00:49:28Z"
        },
        {
          "expectedResult": {
            "status": "INCOMPLIANT",
            "conditionIndex": "299",
            "conditionText": "extract('CA10__startTime__c').beyondLastDays(90)",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2025-07-28T16:54:52Z"
          },
          "Id": "002",
          "CA10__disappearanceTime__c": null,
          "CA10__state__c": "completed",
          "CA10__startTime__c": "2025-04-28T16:54:52Z"
        },
        {
          "expectedResult": {
            "status": "COMPLIANT",
            "conditionIndex": "300",
            "conditionText": "otherwise",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2025-07-28T16:54:52Z"
          },
          "Id": "003",
          "CA10__disappearanceTime__c": null,
          "CA10__state__c": "completed",
          "CA10__startTime__c": "2025-07-01T00:51:18Z"
        },
        {
          "expectedResult": {
            "status": "COMPLIANT",
            "conditionIndex": "300",
            "conditionText": "otherwise",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2025-07-28T16:54:52Z"
          },
          "Id": "004",
          "CA10__disappearanceTime__c": null,
          "CA10__state__c": "completed",
          "CA10__startTime__c": "2025-04-29T16:54:52Z"
        },
        {
          "expectedResult": {
            "status": "INAPPLICABLE",
            "conditionIndex": "199",
            "conditionText": "extract('CA10__state__c') != 'completed'",
            "runtimeError": null
          },
          "context": {
            "snapshotTime": "2025-07-28T16:54:52Z"
          },
          "Id": "005",
          "CA10__disappearanceTime__c": null,
          "CA10__state__c": "error",
          "CA10__startTime__c": "2025-04-29T16:54:52Z"
        }
      ]
  - path: /types/CA10__CaAwsSnapshot__c/object.extracts.yaml
    md5Hash: 03CE90E6827F041BFA62AB505854D545
    content: "# yaml-language-server: $schema=../../schema/Extracts.schema.json\n\
      ---\nextracts:\n# Values: Yea | No. Nullable null is equal to No. \n  - name:\
      \ CA10__publicAccessible__c\n    value:\n      FIELD: \n        path: CA10__publicAccessible__c\n\
      \        # undeterminedIf:\n        #   noAccessDelegate:\n        #     path:\
      \ \"CA10__publicAccessible__c\"\n        #     currentStateMessage: \"Unable\
      \ to determined Public Access. Possible Permissions issues with ec2:DescribeSnapshotAttribute.\"\
      \n# Not Nullable. Can't have no access retrieved via ec2:DescribeSnapshots.\n\
      \  - name: \"CA10__startTime__c\"\n    value:\n      FIELD:\n        path: \"\
      CA10__startTime__c\"\n        undeterminedIf:\n          isEmpty: \"Corrupted\
      \ data. Snapshot Start Time cannot be empty.\"\n# Values: pending | completed\
      \ | error | recoverable | recovering \n# Not Nullable. Can't have no access\
      \ retrieved via ec2:DescribeSnapshots.\n  - name: \"CA10__state__c\"\n    value:\n\
      \      FIELD:\n        path: \"CA10__state__c\"\n        undeterminedIf:\n \
      \         isEmpty: \"Corrupted data. Snapshot Start Time cannot be empty.\""
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "001",
    "expectedResult" : {
      "status" : "DISAPPEARED",
      "conditionIndex" : "99",
      "conditionText" : "isDisappeared(CA10__disappearanceTime__c)",
      "runtimeError" : null
    }
  }, {
    "Id" : "002",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "299",
      "conditionText" : "extract('CA10__startTime__c').beyondLastDays(90)",
      "runtimeError" : null
    }
  }, {
    "Id" : "003",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "300",
      "conditionText" : "otherwise",
      "runtimeError" : null
    }
  }, {
    "Id" : "004",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "300",
      "conditionText" : "otherwise",
      "runtimeError" : null
    }
  }, {
    "Id" : "005",
    "expectedResult" : {
      "status" : "INAPPLICABLE",
      "conditionIndex" : "199",
      "conditionText" : "extract('CA10__state__c') != 'completed'",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaAwsSnapshot__c()
  RETURNS ARRAY<STRUCT<
      Id STRING,
      CA10__disappearanceTime__c TIMESTAMP,
      CA10__state__c STRING,
      CA10__startTime__c TIMESTAMP,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2025-07-28T16:54:52Z")
    },
    "Id" : "001",
    "CA10__disappearanceTime__c" : new Date("2025-07-20T04:52:20Z"),
    "CA10__state__c" : "error",
    "CA10__startTime__c" : new Date("2025-07-06T00:49:28Z")
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-07-28T16:54:52Z")
    },
    "Id" : "002",
    "CA10__state__c" : "completed",
    "CA10__startTime__c" : new Date("2025-04-28T16:54:52Z")
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-07-28T16:54:52Z")
    },
    "Id" : "003",
    "CA10__state__c" : "completed",
    "CA10__startTime__c" : new Date("2025-07-01T00:51:18Z")
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-07-28T16:54:52Z")
    },
    "Id" : "004",
    "CA10__state__c" : "completed",
    "CA10__startTime__c" : new Date("2025-04-29T16:54:52Z")
  }, {
    "context" : {
      "snapshotTime" : new Date("2025-07-28T16:54:52Z")
    },
    "Id" : "005",
    "CA10__state__c" : "error",
    "CA10__startTime__c" : new Date("2025-04-29T16:54:52Z")
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaAwsSnapshot__c(
      obj STRUCT<
          Id STRING,
          CA10__disappearanceTime__c TIMESTAMP,
          CA10__state__c STRING,
          CA10__startTime__c TIMESTAMP
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
      var TextLib = new function () {
          this.normalize = function(arg) {
              return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
          };
          this.isEmpty = function(arg) {
              return this.normalize(arg) == '';
          };
          this.isNotEmpty = function(arg) {
              return this.normalize(arg) != '';
          };
          this.equal = function(left, right) {
              return this.normalize(left) == this.normalize(right);
          };
          this.notEqual = function(left, right) {
              return this.normalize(left) != this.normalize(right);
          };
          this.startsWith = function(arg, substring) {
              return this.normalize(arg).startsWith(this.normalize(substring));
          };
          this.endsWith = function(arg, substring) {
              return this.normalize(arg).endsWith(this.normalize(substring));
          };
          this.contains = function(arg, substring) {
              return this.normalize(arg).includes(this.normalize(substring));
          };
          this.containsAll = function(arg, substrings) {
              if (substrings == null || substrings.length === 0) return false;
              let normalizedArg = this.normalize(arg);
              return substrings.every(sub => normalizedArg.includes(this.normalize(sub)));
          };
          this.containsAny = function(arg, substrings) {
              if (substrings == null || substrings.length === 0) return false;
              let normalizedArg = this.normalize(arg);
              return substrings.some(sub => normalizedArg.includes(this.normalize(sub)));
          };
      }();
      var IsEmptyLib = new function () {
          this.simpleIsEmpty = function(arg) {
              return arg == null;
          };
          this.simpleIsNotEmpty = function(arg) {
              return arg != null;
          };
      }();
      var todayMinus90Day = new Date(snapshotTime.toISOString().substr(0,10)+'T00:00:00.000Z').getTime() + (-90 * 86400000);
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From AWS [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function fieldChecked4() {
          if (TextLib.isEmpty(obj.CA10__state__c)) {
              throw new Error("UNDETERMINED condition:101", {cause: {status: 'UNDETERMINED', conditionIndex: 101, conditionText: "CA10__state__c.isEmpty()", currentStateMessage: "Corrupted data. Snapshot Start Time cannot be empty.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__state__c;
      }
      function extract3() { if (!this.out) { this.out = fieldChecked4(); } return this.out; };
      references1.push('State [obj.CA10__state__c]: ' + obj.CA10__state__c);
      try {
          if (TextLib.notEqual(extract3.call(extract3), 'completed')) {
              return {status: 'INAPPLICABLE', conditionIndex: 199, conditionText: "extract('CA10__state__c') != 'completed'", currentStateMessage: "The snapshot is not completed.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      // condition[2], conditionIndex:[200..299]
      function fieldChecked7() {
          if (IsEmptyLib.simpleIsEmpty(obj.CA10__startTime__c)) {
              throw new Error("UNDETERMINED condition:201", {cause: {status: 'UNDETERMINED', conditionIndex: 201, conditionText: "CA10__startTime__c.isEmpty()", currentStateMessage: "Corrupted data. Snapshot Start Time cannot be empty.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__startTime__c;
      }
      function extract6() { if (!this.out) { this.out = fieldChecked7(); } return this.out; };
      references1.push('Start Time [obj.CA10__startTime__c]: ' + obj.CA10__startTime__c);
      try {
          if (extract6.call(extract6) != null && extract6.call(extract6).getTime() < todayMinus90Day) {
              return {status: 'INCOMPLIANT', conditionIndex: 299, conditionText: "extract('CA10__startTime__c').beyondLastDays(90)", currentStateMessage: "EBS Snapshot is 90 days old or more.", currentStateReferences: references1.join('\n'), remediation: "Consider deleting or archiving the old snapshot.", runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      return {status: 'COMPLIANT', conditionIndex: 300, conditionText: "otherwise", currentStateMessage: "EBS snapshot is less than 90 days old.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.Id AS Id,
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          sObject.CA10__state__c AS CA10__state__c,
          sObject.CA10__startTime__c AS CA10__startTime__c,
          process_CA10__CaAwsSnapshot__c(
              STRUCT(
                  sObject.Id AS Id,
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
                  sObject.CA10__state__c AS CA10__state__c,
                  sObject.CA10__startTime__c AS CA10__startTime__c
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaAwsSnapshot__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
